Index: src/Box.cpp
===================================================================
--- src/Box.cpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Box.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -14,4 +14,6 @@
 #include "Matrix.hpp"
 #include "vector.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/ShapeOps.hpp"
 
 #include "Helpers/Assert.hpp"
@@ -139,4 +141,9 @@
 }
 
+Shape Box::getShape() const{
+  return transform(Cuboid(Vector(0,0,0),Vector(1,1,1)),(*M));
+
+}
+
 Box &Box::operator=(const Box &src){
   if(&src!=this){
Index: src/Box.hpp
===================================================================
--- src/Box.hpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Box.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -11,4 +11,5 @@
 class Matrix;
 class Vector;
+class Shape;
 
 #include <list>
@@ -89,4 +90,6 @@
   double periodicDistance(const Vector &point1,const Vector &point2) const;
 
+  Shape getShape() const;
+
 private:
   Matrix *M;    //!< Defines the layout of the box
Index: src/Descriptors/AtomShapeDescriptor.cpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/Descriptors/AtomShapeDescriptor.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,26 @@
+/*
+ * AtomShapeDescriptor.cpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#include "AtomShapeDescriptor.hpp"
+#include "AtomShapeDescriptor_impl.hpp"
+
+#include "atom.hpp"
+
+AtomShapeDescriptor_impl::AtomShapeDescriptor_impl(const Shape &_shape) :
+  shape(_shape)
+{}
+
+AtomShapeDescriptor_impl::~AtomShapeDescriptor_impl(){}
+
+bool AtomShapeDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom){
+  return shape.isInside(*atom.second->node);
+}
+
+
+AtomDescriptor AtomByShape(const Shape &shape){
+  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomShapeDescriptor_impl(shape)));
+}
Index: src/Descriptors/AtomShapeDescriptor.hpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/Descriptors/AtomShapeDescriptor.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,17 @@
+/*
+ * AtomShapeDescriptor.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMSHAPEDESCRIPTOR_HPP_
+#define ATOMSHAPEDESCRIPTOR_HPP_
+
+#include "Descriptors/AtomDescriptor.hpp"
+
+class Shape;
+
+AtomDescriptor AtomByShape(const Shape &shape);
+
+#endif /* ATOMSHAPEDESCRIPTOR_HPP_ */
Index: src/Descriptors/AtomShapeDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor_impl.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/Descriptors/AtomShapeDescriptor_impl.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,26 @@
+/*
+ * AtomShapeDescriptor_impl.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMSHAPEDESCRIPTOR_IMPL_HPP_
+#define ATOMSHAPEDESCRIPTOR_IMPL_HPP_
+
+#include "Descriptors/AtomDescriptor_impl.hpp"
+
+#include "Shapes/Shape.hpp"
+
+class AtomShapeDescriptor_impl : public AtomDescriptor_impl
+{
+public:
+  AtomShapeDescriptor_impl(const Shape&);
+  virtual  ~AtomShapeDescriptor_impl();
+
+  bool predicate(std::pair<atomId_t,atom*> atom);
+private:
+  Shape shape;
+};
+
+#endif /* ATOMSHAPEDESCRIPTOR_IMPL_HPP_ */
Index: src/Exceptions/NotOnSurfaceException.cpp
===================================================================
--- src/Exceptions/NotOnSurfaceException.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/Exceptions/NotOnSurfaceException.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,21 @@
+/*
+ * NotOnSurfaceException.cpp
+ *
+ *  Created on: Jul 14, 2010
+ *      Author: crueger
+ */
+
+#include "NotOnSurfaceException.hpp"
+
+using namespace std;
+
+NotOnSurfaceException::NotOnSurfaceException(string _file, int _line) :
+  ShapeException(_file,_line)
+{}
+
+NotOnSurfaceException::~NotOnSurfaceException() throw ()
+{}
+
+const char* NotOnSurfaceException::what() const throw(){
+  return "Given point did not lie on surface of Shape";
+}
Index: src/Exceptions/NotOnSurfaceException.hpp
===================================================================
--- src/Exceptions/NotOnSurfaceException.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/Exceptions/NotOnSurfaceException.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,22 @@
+/*
+ * NotOnSurfaceException.hpp
+ *
+ *  Created on: Jul 14, 2010
+ *      Author: crueger
+ */
+
+#ifndef NOTONSURFACEEXCEPTION_HPP_
+#define NOTONSURFACEEXCEPTION_HPP_
+
+#include "Exceptions/ShapeException.hpp"
+
+class NotOnSurfaceException : public ShapeException
+{
+public:
+  NotOnSurfaceException(std::string _file, int _line);
+  virtual ~NotOnSurfaceException() throw();
+
+  virtual const char* what() const throw();
+};
+
+#endif /* NOTONSURFACEEXCEPTION_HPP_ */
Index: src/Exceptions/ShapeException.cpp
===================================================================
--- src/Exceptions/ShapeException.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/Exceptions/ShapeException.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,15 @@
+/*
+ * ShapeException.cpp
+ *
+ *  Created on: Jul 14, 2010
+ *      Author: crueger
+ */
+
+#include "ShapeException.hpp"
+
+ShapeException::ShapeException(std::string file, int line) :
+  CustomException(file,line)
+{}
+
+ShapeException::~ShapeException() throw ()
+{}
Index: src/Exceptions/ShapeException.hpp
===================================================================
--- src/Exceptions/ShapeException.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/Exceptions/ShapeException.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,20 @@
+/*
+ * ShapeException.hpp
+ *
+ *  Created on: Jul 14, 2010
+ *      Author: crueger
+ */
+
+#ifndef SHAPEEXCEPTION_HPP_
+#define SHAPEEXCEPTION_HPP_
+
+#include "Exceptions/CustomException.hpp"
+
+class ShapeException : public CustomException
+{
+public:
+  ShapeException(std::string file, int line);
+  virtual ~ShapeException() throw();
+};
+
+#endif /* SHAPEEXCEPTION_HPP_ */
Index: src/Line.cpp
===================================================================
--- src/Line.cpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Line.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -37,4 +37,12 @@
 Line::~Line()
 {}
+
+Line &Line::operator=(const Line& rhs){
+  if(this!=&rhs){
+    origin.reset(new Vector(*rhs.origin));
+    direction.reset(new Vector(*rhs.direction));
+  }
+  return *this;
+}
 
 
@@ -211,4 +219,31 @@
 }
 
+Line Line::rotateLine(const Line &rhs, double alpha) const{
+  Vector lineOrigin = rotateVector(rhs.getOrigin(),alpha);
+  Vector helper = rhs.getDirection();
+  // rotate the direction without considering the ofset
+  pair<Vector,Vector> parts = helper.partition(*direction);
+  Vector lineDirection = parts.first;
+  Vector a = parts.second;
+  if(!a.IsZero()){
+    // construct a vector that is orthogonal to a and direction and has length |a|
+    Vector y = a;
+    // direction is normalized, so the result has length |a|
+    y.VectorProduct(*direction);
+
+    lineDirection += cos(alpha) * a + sin(alpha) * y;
+  }
+  return Line(lineOrigin,lineDirection);
+}
+
+Plane Line::rotatePlane(const Plane &rhs, double alpha) const{
+  vector<Vector> points = rhs.getPointsOnPlane();
+  transform(points.begin(),
+            points.end(),
+            points.begin(),
+            boost::bind(&Line::rotateVector,this,_1,alpha));
+  return Plane(points[0],points[1],points[2]);
+}
+
 Plane Line::getOrthogonalPlane(const Vector &origin) const{
   return Plane(getDirection(),origin);
@@ -234,4 +269,22 @@
 }
 
+LinePoint Line::getLinePoint(const Vector &point) const{
+  ASSERT(isContained(point),"Line point queried for point not on line");
+  Vector helper = point - (*origin);
+  double param = helper.ScalarProduct(*direction);
+  return LinePoint(*this,param);
+}
+
+LinePoint Line::posEndpoint() const{
+  return LinePoint(*this, numeric_limits<double>::infinity());
+}
+LinePoint Line::negEndpoint() const{
+  return LinePoint(*this,-numeric_limits<double>::infinity());
+}
+
+bool operator==(const Line &x,const Line &y){
+  return *x.origin == *y.origin && *x.direction == *y.direction;
+}
+
 Line makeLineThrough(const Vector &x1, const Vector &x2){
   if(x1==x2){
@@ -240,2 +293,48 @@
   return Line(x1,x1-x2);
 }
+
+
+/******************************** Points on the line ********************/
+
+LinePoint::LinePoint(const LinePoint &src) :
+  line(src.line),param(src.param)
+{}
+
+LinePoint::LinePoint(const Line &_line, double _param) :
+  line(_line),param(_param)
+{}
+
+LinePoint& LinePoint::operator=(const LinePoint &src){
+  line=src.line;
+  param=src.param;
+  return *this;
+}
+
+Vector LinePoint::getPoint() const{
+  ASSERT(!isInfinite(),"getPoint() on infinite LinePoint called");
+  return (*line.origin)+param*(*line.direction);
+}
+
+Line LinePoint::getLine() const{
+  return line;
+}
+
+bool LinePoint::isInfinite() const{
+  return isPosInfinity() || isNegInfinity();
+}
+bool LinePoint::isPosInfinity() const{
+  return param == numeric_limits<double>::infinity();
+}
+bool LinePoint::isNegInfinity() const{
+  return param ==-numeric_limits<double>::infinity();
+}
+
+bool operator==(const LinePoint &x, const LinePoint &y){
+  ASSERT(x.line==y.line,"Operation on two points of different lines");
+  return x.param == y.param;
+
+}
+bool operator<(const LinePoint &x, const LinePoint &y){
+  ASSERT(x.line==y.line,"Operation on two points of different lines");
+  return x.param<y.param;
+}
Index: src/Line.hpp
===================================================================
--- src/Line.hpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Line.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -16,11 +16,16 @@
 class Vector;
 class Plane;
+class LinePoint;
 
 class Line : public Space
 {
+  friend bool operator==(const Line&,const Line&);
+  friend class LinePoint;
 public:
   Line(const Vector &_origin, const Vector &_direction);
   Line(const Line& _src);
   virtual ~Line();
+
+  Line &operator=(const Line& rhs);
 
   virtual double distance(const Vector &point) const;
@@ -35,8 +40,16 @@
 
   Vector rotateVector(const Vector &rhs, double alpha) const;
+  Line rotateLine(const Line &rhs, double alpha) const;
+  Plane rotatePlane(const Plane &rhs, double alpha) const;
 
   Plane getOrthogonalPlane(const Vector &origin) const;
 
   std::vector<Vector> getSphereIntersections() const;
+
+  LinePoint getLinePoint(const Vector&) const;
+  LinePoint posEndpoint() const;
+  LinePoint negEndpoint() const;
+
+
 
 private:
@@ -45,4 +58,6 @@
 };
 
+bool operator==(const Line&,const Line&);
+
 /**
  * Named constructor to make a line through two points
@@ -50,3 +65,36 @@
 Line makeLineThrough(const Vector &x1, const Vector &x2);
 
+/**
+ * Class for representing points on a line
+ * These objects allow comparison of points on the same line as well as specifying the
+ * infinite "endpoints" of a line.
+ */
+class LinePoint{
+  friend class Line;
+  friend bool operator==(const LinePoint&, const LinePoint&);
+  friend bool operator<(const LinePoint&, const LinePoint&);
+public:
+  LinePoint(const LinePoint&);
+  LinePoint& operator=(const LinePoint&);
+  Vector getPoint() const;
+  Line getLine() const;
+  bool isInfinite() const;
+  bool isPosInfinity() const;
+  bool isNegInfinity() const;
+
+private:
+  LinePoint(const Line&,double);
+  Line line;
+  double param;
+};
+
+bool operator==(const LinePoint&, const LinePoint&);
+bool operator<(const LinePoint&, const LinePoint&);
+
+inline bool operator!= (const LinePoint& x, const LinePoint& y) { return !(x==y); }
+inline bool operator>  (const LinePoint& x, const LinePoint& y) { return y<x; }
+inline bool operator<= (const LinePoint& x, const LinePoint& y) { return !(y<x); }
+inline bool operator>= (const LinePoint& x, const LinePoint& y) { return !(x<y); }
+
+
 #endif /* LINE_HPP_ */
Index: src/LineSegment.cpp
===================================================================
--- src/LineSegment.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/LineSegment.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,90 @@
+/*
+ * LineSegment.cpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#include "LineSegment.hpp"
+#include "Helpers/Assert.hpp"
+
+#include "Line.hpp"
+#include "vector.hpp"
+
+using namespace std;
+
+LineSegment::LineSegment(const Vector &point1,const Vector &point2){
+  line.reset(new Line(point1,point1-point2));
+  begin.reset(new LinePoint(line->getLinePoint(point1)));
+  end.reset(new LinePoint(line->getLinePoint(point2)));
+}
+
+LineSegment::LineSegment(const LinePoint &lp1,const LinePoint &lp2){
+  ASSERT(lp1.getLine()==lp2.getLine(),"Cannot make a lineSegment with two different lines");
+  line.reset(new Line(lp1.getLine()));
+  begin.reset(new LinePoint(lp1));
+  end.reset(new LinePoint(lp2));
+}
+LineSegment::LineSegment(const LineSegment &src)
+{
+  line.reset(new Line(*src.line));
+  begin.reset(new LinePoint(*src.begin));
+  end.reset(new LinePoint(*src.end));
+}
+LineSegment::~LineSegment(){
+}
+LineSegment &LineSegment::operator=(const LineSegment &src){
+  if(this!=&src){
+    lineptr _line(new Line(*src.line));
+    pointptr _begin(new LinePoint(*src.begin));
+    pointptr _end(new LinePoint(*src.end));
+    line = _line;
+    begin = _begin;
+    end = _end;
+  }
+  return *this;
+}
+
+bool LineSegment::isContained(const Vector &point) const{
+  if(!line->isContained(point)){
+    return false;
+  }
+  LinePoint lp = line->getLinePoint(point);
+  return *begin <= lp && lp <= *end;
+}
+
+bool LineSegment::isContained(const LinePoint &lp) const{
+  ASSERT(lp.getLine()==*line,"Cannot compare Linepoints from different Lines");
+  return *begin <= lp && lp <= *end;
+}
+
+bool LineSegment::overlaps(const LineSegment &lineSeg) const{
+  ASSERT(*lineSeg.line == *line,"Cannot compare Linesegments from different Lines");
+  // mutual comparison of endpoints
+  return lineSeg.isContained(*end) || isContained(*lineSeg.end);
+}
+
+bool LineSegment::hasZeroLength() const{
+  return *begin==*end;
+}
+
+LinePoint LineSegment::getBegin() const{
+  return *begin;
+}
+
+LinePoint LineSegment::getEnd() const{
+  return *end;
+}
+
+Line LineSegment::getLine() const{
+  return *line;
+}
+
+bool operator==(const LineSegment &x,const LineSegment &y){
+  ASSERT(*x.line==*y.line,"Comparison of Linesegments from different lines");
+  return *x.begin == *y.begin && *x.end == *y.end;
+}
+bool operator<(const LineSegment &x,const LineSegment &y){
+  ASSERT(*x.line==*y.line,"Comparison of Linesegments from different lines");
+  return (*x.begin != *y.begin) ? *x.begin<*y.begin:*x.end<*y.end;
+}
Index: src/LineSegment.hpp
===================================================================
--- src/LineSegment.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/LineSegment.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,48 @@
+/*
+ * LineSegment.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef LINESEGMENT_HPP_
+#define LINESEGMENT_HPP_
+
+#include <memory>
+
+class Vector;
+class Line;
+class LinePoint;
+
+class LineSegment
+{
+  friend bool operator==(const LineSegment&,const LineSegment&);
+  friend bool operator<(const LineSegment&,const LineSegment&);
+
+  typedef std::auto_ptr<LinePoint> pointptr;
+  typedef std::auto_ptr<Line> lineptr;
+public:
+  LineSegment(const Vector&,const Vector&);
+  LineSegment(const LinePoint&,const LinePoint&);
+  LineSegment(const LineSegment&);
+  virtual ~LineSegment();
+  LineSegment &operator=(const LineSegment&);
+
+  bool isContained(const Vector &) const;
+  bool isContained(const LinePoint &) const;
+  bool overlaps(const LineSegment&) const;
+  bool hasZeroLength() const;
+  LinePoint getBegin() const;
+  LinePoint getEnd() const;
+  Line getLine() const;
+
+private:
+  pointptr begin;
+  pointptr end;
+  lineptr line;
+};
+
+bool operator==(const LineSegment&,const LineSegment&);
+bool operator<(const LineSegment&,const LineSegment&);
+
+#endif /* LINESEGMENT_HPP_ */
Index: src/LineSegmentSet.cpp
===================================================================
--- src/LineSegmentSet.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/LineSegmentSet.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,223 @@
+/*
+ * LineSegmentSet.cpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#include "LineSegmentSet.hpp"
+
+#include "Helpers/Assert.hpp"
+#include "Line.hpp"
+#include "LineSegment.hpp"
+
+#include "Helpers/Range.hpp"
+
+#include <algorithm>
+#include <boost/bind.hpp>
+
+using namespace std;
+
+LineSegmentSet::LineSegmentSet(const Line &_line) :
+  line(new Line(_line))
+{}
+
+LineSegmentSet::LineSegmentSet(const LineSegmentSet &src)
+{
+  line.reset(new Line(*src.line));
+  segments=src.segments;
+}
+
+LineSegmentSet& LineSegmentSet::operator=(const LineSegmentSet &src){
+  if(this!=&src){
+    lineptr _line(new Line(*src.line));
+    segments=src.segments;
+    line = _line;
+  }
+  return *this;
+}
+
+void LineSegmentSet::insert(const LineSegment &lineSeg){
+  ASSERT(*line==lineSeg.getLine(),"Inserted LineSegment was not from the line of the set");
+  // we might get messed up sets
+  if(lineSeg.hasZeroLength()){
+    // nothing to do here... there is practically nothing that is being inserted
+    return;
+  }
+  if(lineSeg.getBegin()>lineSeg.getEnd()){
+    // just insert the reversed set
+    insert(LineSegment(lineSeg.getEnd(),lineSeg.getBegin()));
+    return;
+  }
+  // get the first overlapping segment
+  set_t::iterator begin = find_if(segments.begin(),
+                                  segments.end(),
+                                  boost::bind(&LineSegment::overlaps,lineSeg,_1));
+  // see if we have overlapping segments
+  if(begin==segments.end()){
+    // no overlapping segments... we can just insert and get going
+    segments.insert(lineSeg);
+    return;
+  }
+  // get the last overlapping segment
+  set_t::iterator last = begin;
+  while(last!=segments.end() && lineSeg.overlaps(*last))++last;
+  last--;
+  // all segments between last and end now overlap and both are valid iterators
+  ASSERT(begin!=segments.end() && last!=segments.end(),"ERROR: last or begin are behind end of set");
+  // get the endpoints of the section
+  LinePoint beginPoint = min(begin->getBegin(),lineSeg.getBegin());
+  LinePoint endPoint = max(last->getEnd(),lineSeg.getEnd());
+  LineSegment insertSeg(beginPoint,endPoint);
+  // delete all overlapping segments
+  last++;
+  segments.erase(begin,last);
+  // insert the new combined segments
+  segments.insert(insertSeg);
+}
+
+void LineSegmentSet::erase(const LineSegment &lineSeg){
+  ASSERT(*line==lineSeg.getLine(),"Erased LineSegment was not from the line of the set");
+  // we might get messed up sets
+  if(lineSeg.hasZeroLength()){
+    // nothing to do here... there is practically nothing that is being erase
+    return;
+  }
+  if(lineSeg.getBegin()>lineSeg.getEnd()){
+    // just erase the reversed set
+    erase(LineSegment(lineSeg.getEnd(),lineSeg.getBegin()));
+    return;
+  }
+  // get the first overlapping segment
+  set_t::iterator begin = find_if(segments.begin(),
+                                  segments.end(),
+                                  boost::bind(&LineSegment::overlaps,lineSeg,_1));
+  if(begin==segments.end()){
+    // nothing to erase
+    return;
+  }
+  // get the last overlapping segment
+  set_t::iterator last = begin;
+  while(last!=segments.end() && lineSeg.overlaps(*last))++last;
+  last--;
+  // at the ends there might be two overlapping lineSegments of which parts remain
+  LineSegment beginSegment(begin->getBegin(),lineSeg.getBegin());
+  LineSegment endSegment(lineSeg.getEnd(),last->getEnd());
+  // erase all elements that have been overlapped
+  last++;
+  segments.erase(begin,last);
+  // insert the two segments if they still have space left
+  if(beginSegment.getBegin()<beginSegment.getEnd())
+    segments.insert(beginSegment);
+  if(endSegment.getBegin()<endSegment.getEnd())
+      segments.insert(endSegment);
+}
+
+LineSegmentSet::iterator LineSegmentSet::begin(){
+  return segments.begin();
+}
+LineSegmentSet::const_iterator LineSegmentSet::begin() const{
+  return segments.begin();
+}
+LineSegmentSet::iterator LineSegmentSet::end(){
+  return segments.end();
+}
+LineSegmentSet::const_iterator LineSegmentSet::end() const{
+  return segments.end();
+}
+
+bool LineSegmentSet::isContained(const Vector &point) const{
+  if(!line->isContained(point)){
+    return false;
+  }
+  LinePoint lp = line->getLinePoint(point);
+  for(set_t::iterator iter=segments.begin();iter!=segments.end();++iter){
+    if(iter->isContained(point)){
+      return true;
+    }
+    if(iter->getBegin()>lp){
+      break;
+    }
+  }
+  return false;
+}
+
+Line LineSegmentSet::getLine(){
+  return *line;
+}
+
+LineSegmentSet merge(const LineSegmentSet &x,const LineSegmentSet &y){
+  typedef range<LineSegmentSet::set_t::iterator> itRange;
+  ASSERT(*x.line==*y.line,"Lines of merges LineSegmentSets don't match");
+  LineSegmentSet res(*x.line);
+  // standard merge algorithm with a few modifications to deal with overlapping lines
+  itRange small(x.segments.begin(),x.segments.end());
+  itRange large(y.segments.begin(),y.segments.end());
+  while(small.first!=small.last && large.first != large.last){
+    if(large.first->getBegin()<small.first->getBegin()){
+      itRange tmp = small;
+      small = large;
+      large = tmp;
+    }
+
+    if(small.first->overlaps(*large.first)){
+      // get all overlapping segments from larger part
+      LineSegmentSet::set_t::iterator last = large.first;
+      while(last!=large.last && small.first->overlaps(*last))++last;
+      last--;
+      // get the endpoint of the new segment to be inserted
+      LinePoint lpEnd = max(small.first->getEnd(),last->getEnd());
+      res.segments.insert(LineSegment(small.first->getBegin(),lpEnd));
+      large.first=last; ++large.first; // all overlapping segments of the larger part have been dealt with
+    }
+    else{
+      // no overlap, we can just insert
+      res.segments.insert(*small.first);
+    }
+    ++small.first;
+  }
+  // deal with the rest of the iterator
+  // we don't know which one is done, so we just do both
+  res.segments.insert(small.first,small.last);
+  res.segments.insert(large.first,large.last);
+  return res;
+}
+
+LineSegmentSet intersect(const LineSegmentSet &x, const LineSegmentSet &y){
+  typedef range<LineSegmentSet::set_t::iterator> itRange;
+  ASSERT(*x.line==*y.line,"Lines of merges LineSegmentSets don't match");
+  LineSegmentSet res(*x.line);
+  itRange small(x.segments.begin(),x.segments.end());
+  itRange large(y.segments.begin(),y.segments.end());
+
+  while(small.first!=small.last && large.first != large.last){
+    if(large.first->getBegin()<small.first->getBegin()){
+      itRange tmp = small;
+      small = large;
+      large = tmp;
+    }
+    // add overlapping parts of segments from large
+    while(large.first!=large.last && small.first->overlaps(*large.first)){
+      LinePoint lpEnd = min(small.first->getEnd(),large.first->getEnd());
+      res.segments.insert(LineSegment(large.first->getBegin(),lpEnd));
+      ++large.first;
+    }
+    ++small.first;
+  }
+  return res;
+}
+
+LineSegmentSet invert(const LineSegmentSet &x){
+  LineSegmentSet res(*x.line);
+  LinePoint lpBegin = x.line->negEndpoint();
+  for(LineSegmentSet::set_t::iterator iter = x.segments.begin();iter!=x.segments.end();++iter){
+    if(lpBegin!=iter->getBegin())
+      res.segments.insert(LineSegment(lpBegin,iter->getBegin()));
+    // the end of the current scanned segment is the beginning of the next one to insert
+    lpBegin = iter->getEnd();
+  }
+  // we might need to extend to infinity
+  if(!lpBegin.isPosInfinity())
+    res.segments.insert(LineSegment(lpBegin,x.line->posEndpoint()));
+  return res;
+}
Index: src/LineSegmentSet.hpp
===================================================================
--- src/LineSegmentSet.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
+++ src/LineSegmentSet.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -0,0 +1,52 @@
+/*
+ * LineSegmentSet.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef LINESEGMENTSET_HPP_
+#define LINESEGMENTSET_HPP_
+
+#include <memory>
+#include <set>
+
+class Vector;
+class Line;
+class LineSegment;
+
+class LineSegmentSet {
+  friend LineSegmentSet merge(const LineSegmentSet&,const LineSegmentSet&);
+  friend LineSegmentSet intersect(const LineSegmentSet&, const LineSegmentSet&);
+  friend LineSegmentSet invert(const LineSegmentSet &);
+
+  typedef std::set<LineSegment> set_t;
+  typedef std::auto_ptr<Line> lineptr;
+public:
+  typedef set_t::iterator iterator;
+  typedef set_t::const_iterator const_iterator;
+
+  LineSegmentSet(const Line&);
+  LineSegmentSet(const LineSegmentSet&);
+  LineSegmentSet& operator=(const LineSegmentSet&);
+
+  void insert(const LineSegment&);
+  void erase(const LineSegment&);
+
+  iterator       begin();
+  const_iterator begin() const;
+  iterator       end();
+  const_iterator end()   const;
+
+  bool isContained(const Vector &) const;
+  Line getLine();
+private:
+  lineptr line;
+  set_t segments;
+};
+
+LineSegmentSet merge(const LineSegmentSet&,const LineSegmentSet&);
+LineSegmentSet intersect(const LineSegmentSet&, const LineSegmentSet&);
+LineSegmentSet invert(const LineSegmentSet &);
+
+#endif /* LINESEGMENTSET_HPP_ */
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Makefile.am	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -84,4 +84,6 @@
   Exceptions/MissingValueException.cpp \
   Exceptions/NotInvertibleException.cpp \
+  Exceptions/NotOnSurfaceException.cpp \
+  Exceptions/ShapeException.cpp \
   Exceptions/ParseError.cpp \
   Exceptions/SkewException.cpp \
@@ -95,4 +97,6 @@
   Exceptions/MissingValueException.hpp \
   Exceptions/NotInvertibleException.hpp \
+  Exceptions/NotOnSurfaceException.hpp \
+  Exceptions/ShapeException.hpp \
   Exceptions/ParseError.hpp \
   Exceptions/SkewException.hpp \
@@ -153,4 +157,5 @@
   Descriptors/AtomIdDescriptor.cpp \
   Descriptors/AtomSelectionDescriptor.cpp \
+  Descriptors/AtomShapeDescriptor.cpp \
   Descriptors/AtomTypeDescriptor.cpp \
   Descriptors/MoleculeDescriptor.cpp \
@@ -165,4 +170,5 @@
   Descriptors/AtomIdDescriptor.hpp \
   Descriptors/AtomSelectionDescriptor.hpp \
+  Descriptors/AtomShapeDescriptor.hpp \
   Descriptors/AtomTypeDescriptor.hpp \
   Descriptors/MoleculeDescriptor.hpp \
@@ -214,4 +220,6 @@
   leastsquaremin.cpp \
   Line.cpp \
+  LineSegment.cpp \
+  LineSegmentSet.cpp \
   linkedcell.cpp \
   log.cpp \
@@ -265,4 +273,6 @@
   leastsquaremin.hpp \
   Line.hpp \
+  LineSegment.hpp \
+  LineSegmentSet.hpp \
   linkedcell.hpp \
   lists.hpp \
Index: src/Matrix.cpp
===================================================================
--- src/Matrix.cpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Matrix.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -213,4 +213,11 @@
 }
 
+Matrix Matrix::transpose() const{
+  MatrixContent *newContent = new MatrixContent();
+  gsl_matrix_transpose_memcpy(newContent->content, content->content);
+  Matrix res = Matrix(newContent);
+  return res;
+}
+
 Matrix &Matrix::operator*=(const double factor){
   gsl_matrix_scale(content->content, factor);
Index: src/Matrix.hpp
===================================================================
--- src/Matrix.hpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Matrix.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -96,4 +96,6 @@
   Matrix invert() const;
 
+  Matrix transpose() const;
+
   // operators
   Matrix &operator=(const Matrix&);
Index: src/Plane.cpp
===================================================================
--- src/Plane.cpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Plane.cpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -15,4 +15,5 @@
 #include "verbose.hpp"
 #include "Helpers/Assert.hpp"
+#include "helpers.hpp"
 #include <cmath>
 #include "Line.hpp"
@@ -106,4 +107,12 @@
 Plane::~Plane()
 {}
+
+Plane &Plane::operator=(const Plane &rhs){
+  if(&rhs!=this){
+    normalVector.reset(new Vector(*rhs.normalVector));
+    offset = rhs.offset;
+  }
+  return *this;
+}
 
 
@@ -188,4 +197,9 @@
 }
 
+bool Plane::onSameSide(const Vector &point1,const Vector &point2) const{
+  return sign(point1.ScalarProduct(*normalVector)-offset) ==
+         sign(point2.ScalarProduct(*normalVector)-offset);
+}
+
 /************ Methods inherited from Space ****************/
 
@@ -207,4 +221,8 @@
 // Operators
 
+bool operator==(const Plane &x,const Plane &y){
+  return *x.normalVector == *y.normalVector && x.offset == y.offset;
+}
+
 ostream &operator << (ostream &ost,const Plane &p){
   ost << "<" << p.getNormal() << ";x> - " << p.getOffset() << "=0";
Index: src/Plane.hpp
===================================================================
--- src/Plane.hpp	(revision a7b777c63b3b50eee5da3df0edbd51b6e7eaad91)
+++ src/Plane.hpp	(revision 2ad48247b6f9de9eea8821024e501debd95f776e)
@@ -21,4 +21,5 @@
 class Plane : public Space
 {
+  friend bool operator==(const Plane&,const Plane&);
   typedef std::auto_ptr<Vector> vec_ptr;
 public:
@@ -29,4 +30,6 @@
   Plane(const Plane& plane);
   virtual ~Plane();
+
+  Plane &operator=(const Plane&);
 
   // Accessor Functions
@@ -63,4 +66,9 @@
   Line getOrthogonalLine(const Vector &origin) const;
 
+  /**
+   * Test if two points are on the same side of the plane
+   */
+  bool onSameSide(const Vector&,const Vector&) const;
+
   /****** Methods inherited from Space ***********/
 
@@ -73,4 +81,6 @@
 };
 
+bool operator==(const Plane&,const Plane&);
+
 std::ostream &operator<< (std::ostream &ost,const Plane& p);
 
